<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Custom Scroll Behavior</title>
    <style>
        body,
        html {
            height: 100%;
            margin: 0;
            padding: 0;
            font-family: Arial, sans-serif;
        }

        .container {
            height: 3000px;
            /* Просто для примера */
            display: flex;
            flex-direction: column;
        }

        .block {
            border: 1px solid #000;
            display: flex;
            justify-content: center;
            align-items: center;
            font-size: 2em;
        }

        /* Разные цвета для блоков (для наглядности) */
        .block:nth-child(1) {
            height: 100vh;
            background-color: #f0f0f0;
        }

        .block:nth-child(2) {
            height: 200vh;
            /* Увеличиваем высоту для второго блока */
            background-color: #e0e0e0;
            overflow-y: scroll;
            /* Разрешаем прокрутку второго блока */
            display: flex;
            /* Добавляем flex для внутренних блоков */
            flex-direction: column;
            /* Располагаем внутренние блоки вертикально */
        }

        .block:nth-child(3) {
            height: 100vh;
            background-color: #d0d0d0;
        }

        .inner-block {
            border: 1px solid #ccc;
            margin: 10px;
            height: 100vh;
            /* Высота внутренних блоков - 100% высоты экрана */
        }
    </style>
</head>

<body>
    <div class="container">
        <div class="block">1</div>
        <div class="block" id="scrollBlock">
            <div class="inner-block">Inner Block 1</div>
            <div class="inner-block">Inner Block 2</div>
            <div class="inner-block">Inner Block 3</div>
        </div>
        <div class="block">3</div>
    </div>

    <script>
        // Получаем второй блок
        const scrollBlock = document.getElementById('scrollBlock');

        // Флаг, который показывает, была ли уже обработка прокрутки второго блока
        let isScrolled = false;

        // Отслеживаем событие прокрутки второго блока
        scrollBlock.addEventListener('scroll', function () {
            // Проверяем, если прокрутка достигает второго блока
            if (!isScrolled && scrollBlock.scrollTop >= scrollBlock.offsetTop) {
                isScrolled = true; // Устанавливаем флаг, чтобы не повторять обработку

                // Устанавливаем прокрутку только для второго блока
                scrollBlock.style.overflowY = 'scroll';
            }
        });

        // Возвращаем стандартное поведение прокрутки после завершения прокрутки второго блока
        scrollBlock.addEventListener('scroll', function () {
            const scrollBottom = scrollBlock.scrollHeight - scrollBlock.scrollTop === scrollBlock.clientHeight;
            if (scrollBottom && isScrolled) {
                scrollBlock.style.overflowY = 'hidden'; // Отключаем прокрутку второго блока
            }
        });
    </script>
</body>

</html>